--- framework/src/objc/DummyProtocolHandler.m.orig	Fri Feb 27 17:24:00 2004
+++ framework/src/objc/DummyProtocolHandler.m	Fri Feb 27 17:24:19 2004
@@ -1,6 +1,6 @@
 /** -*-objc-*-
  *
- *   $Id: DummyProtocolHandler.m,v 1.2 2002/12/12 07:05:15 hisa Exp $
+ *   $Id: DummyProtocolHandler.m.erb,v 1.2 2002/12/12 07:05:15 hisa Exp $
  *
  *   Copyright (c) 2001 FUJIMOTO Hisakuni <hisa@imasy.or.jp>
  *
@@ -74,23 +74,52 @@
 /**** NSGeometry.h ****/
 /**** NSKeyValueCoding.h ****/
 // @interface NSObject ( NSKeyValueCoding )
++ ( BOOL ) accessInstanceVariablesDirectly { return NO; }
 - ( id ) valueForKey : ( NSString * ) key { return nil; }
-- ( void ) takeValue : ( id ) value forKey : ( NSString * ) key {  }
+- ( void ) setValue : ( id ) value forKey : ( NSString * ) key {  }
+- ( BOOL ) validateValue : ( id * ) ioValue forKey : ( NSString * ) inKey error : ( NSError * * ) outError { return NO; }
+- ( NSMutableArray * ) mutableArrayValueForKey : ( NSString * ) key { return nil; }
+- ( id ) valueForKeyPath : ( NSString * ) keyPath { return nil; }
+- ( void ) setValue : ( id ) value forKeyPath : ( NSString * ) keyPath {  }
+- ( BOOL ) validateValue : ( id * ) ioValue forKeyPath : ( NSString * ) inKeyPath error : ( NSError * * ) outError { return NO; }
+- ( NSMutableArray * ) mutableArrayValueForKeyPath : ( NSString * ) keyPath { return nil; }
+- ( id ) valueForUndefinedKey : ( NSString * ) key { return nil; }
+- ( void ) setValue : ( id ) value forUndefinedKey : ( NSString * ) key {  }
+- ( void ) setNilValueForKey : ( NSString * ) key {  }
+- ( NSDictionary * ) dictionaryWithValuesForKeys : ( NSArray * ) keys { return nil; }
+- ( void ) setValuesForKeysWithDictionary : ( NSDictionary * ) keyedValues {  }
++ ( BOOL ) useStoredAccessor { return NO; }
 - ( id ) storedValueForKey : ( NSString * ) key { return nil; }
 - ( void ) takeStoredValue : ( id ) value forKey : ( NSString * ) key {  }
-+ ( BOOL ) accessInstanceVariablesDirectly { return NO; }
-+ ( BOOL ) useStoredAccessor { return NO; }
 
-// @interface NSObject ( NSKeyValueCodingExtras )
-- ( id ) valueForKeyPath : ( NSString * ) key { return nil; }
-- ( void ) takeValue : ( id ) value forKeyPath : ( NSString * ) key {  }
-- ( NSDictionary * ) valuesForKeys : ( NSArray * ) keys { return nil; }
-- ( void ) takeValuesFromDictionary : ( NSDictionary * ) dictionary {  }
-
-// @interface NSObject ( NSKeyValueCodingException )
+// @interface NSObject ( NSDeprecatedKeyValueCoding )
+- ( void ) takeValue : ( id ) value forKey : ( NSString * ) key {  }
+- ( void ) takeValue : ( id ) value forKeyPath : ( NSString * ) keyPath {  }
 - ( id ) handleQueryWithUnboundKey : ( NSString * ) key { return nil; }
 - ( void ) handleTakeValue : ( id ) value forUnboundKey : ( NSString * ) key {  }
 - ( void ) unableToSetNilForKey : ( NSString * ) key {  }
+- ( NSDictionary * ) valuesForKeys : ( NSArray * ) keys { return nil; }
+- ( void ) takeValuesFromDictionary : ( NSDictionary * ) properties {  }
+
+/**** NSKeyValueObserving.h ****/
+// @interface NSObject ( NSKeyValueObserving )
+- ( void ) observeValueForKeyPath : ( NSString * ) keyPath ofObject : ( id ) object change : ( NSDictionary * ) change context : ( void * ) context {  }
+
+// @interface NSObject ( NSKeyValueObserverRegistration )
+- ( void ) addObserver : ( NSObject * ) observer forKeyPath : ( NSString * ) keyPath options : ( NSKeyValueObservingOptions ) options context : ( void * ) context {  }
+- ( void ) removeObserver : ( NSObject * ) observer forKeyPath : ( NSString * ) keyPath {  }
+
+// @interface NSObject ( NSKeyValueObserverNotification )
+- ( void ) willChangeValueForKey : ( NSString * ) key {  }
+- ( void ) didChangeValueForKey : ( NSString * ) key {  }
+- ( void ) willChange : ( NSKeyValueChange ) change valuesAtIndexes : ( NSIndexSet * ) indexes forKey : ( NSString * ) key {  }
+- ( void ) didChange : ( NSKeyValueChange ) change valuesAtIndexes : ( NSIndexSet * ) indexes forKey : ( NSString * ) key {  }
+
+// @interface NSObject ( NSKeyValueObservingCustomization )
++ ( BOOL ) automaticallyNotifiesObserversForKey : ( NSString * ) key { return NO; }
++ ( void ) setKeys : ( NSArray * ) keys triggerChangeNotificationsForDependentKey : ( NSString * ) dependentKey {  }
+- ( void ) setObservationInfo : ( void * ) observationInfo {  }
+- ( void * ) observationInfo { return nil; }
 
 /**** NSKeyedArchiver.h ****/
 // @interface NSObject ( NSKeyedArchiverDelegate )
@@ -157,12 +186,18 @@
 
 /**** NSScanner.h ****/
 /**** NSSet.h ****/
+/**** NSSortDescriptor.h ****/
 /**** NSSpellServer.h ****/
 // @interface NSObject ( NSSpellServerDelegate )
 - ( NSRange ) spellServer : ( NSSpellServer * ) sender findMisspelledWordInString : ( NSString * ) stringToCheck language : ( NSString * ) language wordCount : ( int * ) wordCount countOnly : ( BOOL ) countOnly { NSRange r = {0,0}; return r; }
 - ( NSArray * ) spellServer : ( NSSpellServer * ) sender suggestGuessesForWord : ( NSString * ) word inLanguage : ( NSString * ) language { return nil; }
 - ( void ) spellServer : ( NSSpellServer * ) sender didLearnWord : ( NSString * ) word inLanguage : ( NSString * ) language {  }
 - ( void ) spellServer : ( NSSpellServer * ) sender didForgetWord : ( NSString * ) word inLanguage : ( NSString * ) language {  }
+- ( NSArray * ) spellServer : ( NSSpellServer * ) sender suggestCompletionsForPartialWordRange : ( NSRange ) range inString : ( NSString * ) string language : ( NSString * ) language { return nil; }
+
+/**** NSStream.h ****/
+// @interface NSObject ( NSStreamDelegateEventExtensions )
+- ( void ) stream : ( NSStream * ) aStream handleEvent : ( NSStreamEvent ) eventCode {  }
 
 /**** NSString.h ****/
 /**** NSTask.h ****/
@@ -180,6 +215,29 @@
 - ( void ) URL : ( NSURL * ) sender resourceDidFailLoadingWithReason : ( NSString * ) reason {  }
 
 /**** NSValue.h ****/
+/**** NSXMLParser.h ****/
+// @interface NSObject ( NSXMLParserDelegateEventAdditions )
+- ( void ) parserDidStartDocument : ( NSXMLParser * ) parser {  }
+- ( void ) parserDidEndDocument : ( NSXMLParser * ) parser {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundNotationDeclarationWithName : ( NSString * ) name publicID : ( NSString * ) publicID systemID : ( NSString * ) systemID {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundUnparsedEntityDeclarationWithName : ( NSString * ) name publicID : ( NSString * ) publicID systemID : ( NSString * ) systemID notationName : ( NSString * ) notationName {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundAttributeDeclarationWithName : ( NSString * ) attributeName forElement : ( NSString * ) elementName type : ( NSString * ) type defaultValue : ( NSString * ) defaultValue {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundElementDeclarationWithName : ( NSString * ) elementName model : ( NSString * ) model {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundInternalEntityDeclarationWithName : ( NSString * ) name value : ( NSString * ) value {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundExternalEntityDeclarationWithName : ( NSString * ) name publicID : ( NSString * ) publicID systemID : ( NSString * ) systemID {  }
+- ( void ) parser : ( NSXMLParser * ) parser didStartElement : ( NSString * ) elementName namespaceURI : ( NSString * ) namespaceURI qualifiedName : ( NSString * ) qName attributes : ( NSDictionary * ) attributeDict {  }
+- ( void ) parser : ( NSXMLParser * ) parser didEndElement : ( NSString * ) elementName namespaceURI : ( NSString * ) namespaceURI qualifiedName : ( NSString * ) qName {  }
+- ( void ) parser : ( NSXMLParser * ) parser didStartMappingPrefix : ( NSString * ) prefix toURI : ( NSString * ) namespaceURI {  }
+- ( void ) parser : ( NSXMLParser * ) parser didEndMappingPrefix : ( NSString * ) prefix {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundCharacters : ( NSString * ) string {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundIgnorableWhitespace : ( NSString * ) whitespaceString {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundProcessingInstructionWithTarget : ( NSString * ) target data : ( NSString * ) data {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundComment : ( NSString * ) comment {  }
+- ( void ) parser : ( NSXMLParser * ) parser foundCDATA : ( NSData * ) CDATABlock {  }
+- ( NSData * ) parser : ( NSXMLParser * ) parser resolveExternalEntityName : ( NSString * ) name systemID : ( NSString * ) systemID { return nil; }
+- ( void ) parser : ( NSXMLParser * ) parser parseErrorOccurred : ( NSError * ) parseError {  }
+- ( void ) parser : ( NSXMLParser * ) parser validationErrorOccurred : ( NSError * ) validationError {  }
+
 /**** NSObjectScripting.h ****/
 // @interface NSObject ( NSScripting )
 - ( NSDictionary * ) scriptingProperties { return nil; }
@@ -228,8 +286,55 @@
 - ( BOOL ) scriptingEndsWith : ( id ) object { return NO; }
 - ( BOOL ) scriptingContains : ( id ) object { return NO; }
 
+/**** NSURLConnection.h ****/
+// @interface NSObject ( NSURLConnectionDelegate )
+# 216
+- ( NSURLRequest * ) connection : ( NSURLConnection * ) connection willSendRequest : ( NSURLRequest * ) request redirectResponse : ( NSURLResponse * ) response { return nil; }
+- ( void ) connection : ( NSURLConnection * ) connection didReceiveAuthenticationChallenge : ( NSURLAuthenticationChallenge * ) challenge {  }
+- ( void ) connection : ( NSURLConnection * ) connection didCancelAuthenticationChallenge : ( NSURLAuthenticationChallenge * ) challenge {  }
+- ( void ) connection : ( NSURLConnection * ) connection didReceiveResponse : ( NSURLResponse * ) response {  }
+# 272
+- ( void ) connection : ( NSURLConnection * ) connection didReceiveData : ( NSData * ) data {  }
+- ( void ) connectionDidFinishLoading : ( NSURLConnection * ) connection {  }
+- ( void ) connection : ( NSURLConnection * ) connection didFailWithError : ( NSError * ) error {  }
+- ( NSCachedURLResponse * ) connection : ( NSURLConnection * ) connection willCacheResponse : ( NSCachedURLResponse * ) cachedResponse { return nil; }
+
+/**** NSURLRequest.h ****/
+/**** NSURLDownload.h ****/
+// @interface NSObject ( NSURLDownloadDelegate )
+- ( void ) downloadDidBegin : ( NSURLDownload * ) download {  }
+- ( NSURLRequest * ) download : ( NSURLDownload * ) download willSendRequest : ( NSURLRequest * ) request redirectResponse : ( NSURLResponse * ) redirectResponse { return nil; }
+- ( void ) download : ( NSURLDownload * ) download didReceiveAuthenticationChallenge : ( NSURLAuthenticationChallenge * ) challenge {  }
+- ( void ) download : ( NSURLDownload * ) download didCancelAuthenticationChallenge : ( NSURLAuthenticationChallenge * ) challenge {  }
+- ( void ) download : ( NSURLDownload * ) download didReceiveResponse : ( NSURLResponse * ) response {  }
+- ( void ) download : ( NSURLDownload * ) download didReceiveDataOfLength : ( unsigned ) length {  }
+- ( BOOL ) download : ( NSURLDownload * ) download shouldDecodeSourceDataOfMIMEType : ( NSString * ) encodingType { return NO; }
+- ( void ) download : ( NSURLDownload * ) download decideDestinationWithSuggestedFilename : ( NSString * ) filename {  }
+- ( void ) download : ( NSURLDownload * ) download didCreateDestination : ( NSString * ) path {  }
+- ( void ) downloadDidFinish : ( NSURLDownload * ) download {  }
+- ( void ) download : ( NSURLDownload * ) download didFailWithError : ( NSError * ) error {  }
+
 /**** NSSerialization.h ****/
 /**** NSGraphicsContext.h ****/
+/**** NSAccessibility.h ****/
+// @interface NSObject ( NSAccessibility )
+- ( NSArray * ) accessibilityAttributeNames { return nil; }
+- ( id ) accessibilityAttributeValue : ( NSString * ) attribute { return nil; }
+- ( BOOL ) accessibilityIsAttributeSettable : ( NSString * ) attribute { return NO; }
+- ( void ) accessibilitySetValue : ( id ) value forAttribute : ( NSString * ) attribute {  }
+- ( NSArray * ) accessibilityParameterizedAttributeNames { return nil; }
+- ( id ) accessibilityAttributeValue : ( NSString * ) attribute forParameter : ( id ) parameter { return nil; }
+- ( NSArray * ) accessibilityActionNames { return nil; }
+- ( NSString * ) accessibilityActionDescription : ( NSString * ) action { return nil; }
+- ( void ) accessibilityPerformAction : ( NSString * ) action {  }
+- ( BOOL ) accessibilityIsIgnored { return NO; }
+- ( id ) accessibilityHitTest : ( NSPoint ) point { return nil; }
+- ( id ) accessibilityFocusedUIElement { return nil; }
+
+/**** NSAlert.h ****/
+// @interface NSObject ( NSAlertDelegate )
+- ( BOOL ) alertShowHelp : ( NSAlert * ) alert { return NO; }
+
 /**** NSAppleScriptExtensions.h ****/
 /**** NSApplication.h ****/
 // @interface NSObject ( NSApplicationNotifications )
@@ -251,11 +356,13 @@
 // @interface NSObject ( NSApplicationDelegate )
 - ( NSApplicationTerminateReply ) applicationShouldTerminate : ( NSApplication * ) sender { return (NSApplicationTerminateReply)0; }
 - ( BOOL ) application : ( NSApplication * ) sender openFile : ( NSString * ) filename { return NO; }
+- ( void ) application : ( NSApplication * ) sender openFiles : ( NSArray * ) filenames {  }
 - ( BOOL ) application : ( NSApplication * ) sender openTempFile : ( NSString * ) filename { return NO; }
 - ( BOOL ) applicationShouldOpenUntitledFile : ( NSApplication * ) sender { return NO; }
 - ( BOOL ) applicationOpenUntitledFile : ( NSApplication * ) sender { return NO; }
 - ( BOOL ) application : ( id ) sender openFileWithoutUI : ( NSString * ) filename { return NO; }
 - ( BOOL ) application : ( NSApplication * ) sender printFile : ( NSString * ) filename { return NO; }
+- ( void ) application : ( NSApplication * ) sender printFiles : ( NSArray * ) filenames {  }
 - ( BOOL ) applicationShouldTerminateAfterLastWindowClosed : ( NSApplication * ) sender { return NO; }
 - ( BOOL ) applicationShouldHandleReopen : ( NSApplication * ) sender hasVisibleWindows : ( BOOL ) flag { return NO; }
 - ( NSMenu * ) applicationDockMenu : ( NSApplication * ) sender { return nil; }
@@ -282,6 +389,7 @@
 - ( void ) control : ( NSControl * ) control didFailToValidatePartialString : ( NSString * ) string errorDescription : ( NSString * ) error {  }
 - ( BOOL ) control : ( NSControl * ) control isValidObject : ( id ) obj { return NO; }
 - ( BOOL ) control : ( NSControl * ) control textView : ( NSTextView * ) textView doCommandBySelector : ( SEL ) commandSelector { return NO; }
+- ( NSArray * ) control : ( NSControl * ) control textView : ( NSTextView * ) textView completions : ( NSArray * ) words forPartialWordRange : ( NSRange ) charRange indexOfSelectedItem : ( int * ) index { return nil; }
 
 /**** NSFontManager.h ****/
 // @interface NSObject ( NSFontManagerDelegate )
@@ -290,12 +398,22 @@
 // @interface NSObject ( NSFontManagerResponderMethod )
 - ( void ) changeFont : ( id ) sender {  }
 
+/**** NSFontPanel.h ****/
+// @interface NSObject ( NSFontPanelValidationAdditions )
+- ( unsigned int ) validModesForFontPanel : ( NSFontPanel * ) fontPanel { return (unsigned int)0; }
+
 /**** NSFormCell.h ****/
 /**** NSMatrix.h ****/
 /**** NSMenu.h ****/
 // @interface NSObject ( NSMenuValidation )
 - ( BOOL ) validateMenuItem : ( id < NSMenuItem > ) menuItem { return NO; }
 
+// @interface NSObject ( NSMenuDelegate )
+- ( void ) menuNeedsUpdate : ( NSMenu * ) menu {  }
+- ( int ) numberOfItemsInMenu : ( NSMenu * ) menu { return (int)0; }
+- ( BOOL ) menu : ( NSMenu * ) menu updateItem : ( NSMenuItem * ) item atIndex : ( int ) index shouldCancel : ( BOOL ) shouldCancel { return NO; }
+- ( BOOL ) menuHasKeyEquivalent : ( NSMenu * ) menu forEvent : ( NSEvent * ) event target : ( id * ) target action : ( SEL * ) action { return NO; }
+
 /**** NSColor.h ****/
 /**** NSBitmapImageRep.h ****/
 /**** NSBrowser.h ****/
@@ -309,6 +427,9 @@
 - ( BOOL ) browser : ( NSBrowser * ) sender isColumnValid : ( int ) column { return NO; }
 - ( void ) browserWillScroll : ( NSBrowser * ) sender {  }
 - ( void ) browserDidScroll : ( NSBrowser * ) sender {  }
+- ( float ) browser : ( NSBrowser * ) browser shouldSizeColumn : ( int ) columnIndex forUserResize : ( BOOL ) forUserResize toWidth : ( float ) suggestedWidth { return (float)0; }
+- ( float ) browser : ( NSBrowser * ) browser sizeToFitWidthOfColumn : ( int ) columnIndex { return (float)0; }
+- ( void ) browserColumnConfigurationDidChange : ( NSNotification * ) notification {  }
 
 /**** NSColorPanel.h ****/
 // @interface NSObject ( NSColorPanelResponderMethod )
@@ -346,6 +467,16 @@
 // @interface NSObject ( NSNibAwaking )
 - ( void ) awakeFromNib {  }
 
+/**** NSSpeechRecognizer.h ****/
+// @interface NSObject ( NSSpeechRecognizerDelegate )
+- ( void ) speechRecognizer : ( NSSpeechRecognizer * ) sender didRecognizeCommand : ( id ) command {  }
+
+/**** NSSpeechSynthesizer.h ****/
+// @interface NSObject ( NSSpeechSynthesizerDelegate )
+- ( void ) speechSynthesizer : ( NSSpeechSynthesizer * ) sender didFinishSpeaking : ( BOOL ) finishedSpeaking {  }
+- ( void ) speechSynthesizer : ( NSSpeechSynthesizer * ) sender willSpeakWord : ( NSRange ) characterRange ofString : ( NSString * ) string {  }
+- ( void ) speechSynthesizer : ( NSSpeechSynthesizer * ) sender willSpeakPhoneme : ( short ) phonemeOpcode {  }
+
 /**** NSSplitView.h ****/
 // @interface NSObject ( NSSplitViewDelegate )
 - ( void ) splitView : ( NSSplitView * ) sender resizeSubviewsWithOldSize : ( NSSize ) oldSize {  }
@@ -356,6 +487,7 @@
 - ( BOOL ) splitView : ( NSSplitView * ) sender canCollapseSubview : ( NSView * ) subview { return NO; }
 - ( float ) splitView : ( NSSplitView * ) splitView constrainSplitPosition : ( float ) proposedPosition ofSubviewAt : ( int ) index { return (float)0; }
 
+/**** NSOpenPanel.h ****/
 /**** NSPageLayout.h ****/
 /**** NSPasteboard.h ****/
 // @interface NSObject ( NSPasteboardOwner )
@@ -365,11 +497,13 @@
 /**** NSResponder.h ****/
 /**** NSSavePanel.h ****/
 // @interface NSObject ( NSSavePanelDelegate )
-- ( NSString * ) panel : ( id ) sender userEnteredFilename : ( NSString * ) filename confirmed : ( BOOL ) okFlag { return nil; }
-- ( BOOL ) panel : ( id ) sender isValidFilename : ( NSString * ) filename { return NO; }
 - ( BOOL ) panel : ( id ) sender shouldShowFilename : ( NSString * ) filename { return NO; }
-- ( NSComparisonResult ) panel : ( id ) sender compareFilename : ( NSString * ) file1 with : ( NSString * ) file2 caseSensitive : ( BOOL ) caseSensitive { return (NSComparisonResult)0; }
+- ( NSComparisonResult ) panel : ( id ) sender compareFilename : ( NSString * ) name1 with : ( NSString * ) name2 caseSensitive : ( BOOL ) caseSensitive { return (NSComparisonResult)0; }
+- ( BOOL ) panel : ( id ) sender isValidFilename : ( NSString * ) filename { return NO; }
+- ( NSString * ) panel : ( id ) sender userEnteredFilename : ( NSString * ) filename confirmed : ( BOOL ) okFlag { return nil; }
 - ( void ) panel : ( id ) sender willExpand : ( BOOL ) expanding {  }
+- ( void ) panel : ( id ) sender directoryDidChange : ( NSString * ) path {  }
+- ( void ) panelSelectionDidChange : ( id ) sender {  }
 
 /**** NSScrollView.h ****/
 /**** NSSlider.h ****/
@@ -413,6 +547,7 @@
 - ( NSRect ) windowWillUseStandardFrame : ( NSWindow * ) window defaultFrame : ( NSRect ) newFrame { NSRect r = {{0.0,0.0},{0.0,0.0}}; return r; }
 - ( BOOL ) windowShouldZoom : ( NSWindow * ) window toFrame : ( NSRect ) newFrame { return NO; }
 - ( NSUndoManager * ) windowWillReturnUndoManager : ( NSWindow * ) window { return nil; }
+- ( NSRect ) window : ( NSWindow * ) window willPositionSheet : ( NSWindow * ) sheet usingRect : ( NSRect ) rect { NSRect r = {{0.0,0.0},{0.0,0.0}}; return r; }
 
 /**** NSComboBox.h ****/
 // @interface NSObject ( NSComboBoxDataSource )
@@ -455,6 +590,7 @@
 - ( int ) numberOfRowsInTableView : ( NSTableView * ) tableView { return (int)0; }
 - ( id ) tableView : ( NSTableView * ) tableView objectValueForTableColumn : ( NSTableColumn * ) tableColumn row : ( int ) row { return nil; }
 - ( void ) tableView : ( NSTableView * ) tableView setObjectValue : ( id ) object forTableColumn : ( NSTableColumn * ) tableColumn row : ( int ) row {  }
+- ( void ) tableView : ( NSTableView * ) tableView sortDescriptorsDidChange : ( NSArray * ) oldDescriptors {  }
 - ( BOOL ) tableView : ( NSTableView * ) tv writeRows : ( NSArray * ) rows toPasteboard : ( NSPasteboard * ) pboard { return NO; }
 - ( NSDragOperation ) tableView : ( NSTableView * ) tv validateDrop : ( id < NSDraggingInfo > ) info proposedRow : ( int ) row proposedDropOperation : ( NSTableViewDropOperation ) op { return (NSDragOperation)0; }
 - ( BOOL ) tableView : ( NSTableView * ) tv acceptDrop : ( id < NSDraggingInfo > ) info row : ( int ) row dropOperation : ( NSTableViewDropOperation ) op { return NO; }
@@ -468,6 +604,7 @@
 - ( void ) outlineView : ( NSOutlineView * ) outlineView setObjectValue : ( id ) object forTableColumn : ( NSTableColumn * ) tableColumn byItem : ( id ) item {  }
 - ( id ) outlineView : ( NSOutlineView * ) outlineView itemForPersistentObject : ( id ) object { return nil; }
 - ( id ) outlineView : ( NSOutlineView * ) outlineView persistentObjectForItem : ( id ) item { return nil; }
+- ( void ) outlineView : ( NSOutlineView * ) outlineView sortDescriptorsDidChange : ( NSArray * ) oldDescriptors {  }
 - ( BOOL ) outlineView : ( NSOutlineView * ) olv writeItems : ( NSArray * ) items toPasteboard : ( NSPasteboard * ) pboard { return NO; }
 - ( NSDragOperation ) outlineView : ( NSOutlineView * ) olv validateDrop : ( id < NSDraggingInfo > ) info proposedItem : ( id ) item proposedChildIndex : ( int ) index { return (NSDragOperation)0; }
 - ( BOOL ) outlineView : ( NSOutlineView * ) olv acceptDrop : ( id < NSDraggingInfo > ) info item : ( id ) item childIndex : ( int ) index { return NO; }
@@ -481,6 +618,9 @@
 - ( BOOL ) outlineView : ( NSOutlineView * ) outlineView shouldExpandItem : ( id ) item { return NO; }
 - ( BOOL ) outlineView : ( NSOutlineView * ) outlineView shouldCollapseItem : ( id ) item { return NO; }
 - ( void ) outlineView : ( NSOutlineView * ) outlineView willDisplayOutlineCell : ( id ) cell forTableColumn : ( NSTableColumn * ) tableColumn item : ( id ) item {  }
+- ( void ) outlineView : ( NSOutlineView * ) outlineView mouseDownInHeaderOfTableColumn : ( NSTableColumn * ) tableColumn {  }
+- ( void ) outlineView : ( NSOutlineView * ) outlineView didClickTableColumn : ( NSTableColumn * ) tableColumn {  }
+- ( void ) outlineView : ( NSOutlineView * ) outlineView didDragTableColumn : ( NSTableColumn * ) tableColumn {  }
 
 // @interface NSObject ( NSOutlineViewNotifications )
 - ( void ) outlineViewSelectionDidChange : ( NSNotification * ) notification {  }
@@ -513,6 +653,9 @@
 - ( BOOL ) textView : ( NSTextView * ) view writeCell : ( id < NSTextAttachmentCell > ) cell atIndex : ( unsigned ) charIndex toPasteboard : ( NSPasteboard * ) pboard type : ( NSString * ) type { return NO; }
 - ( NSRange ) textView : ( NSTextView * ) textView willChangeSelectionFromCharacterRange : ( NSRange ) oldSelectedCharRange toCharacterRange : ( NSRange ) newSelectedCharRange { NSRange r = {0,0}; return r; }
 - ( void ) textViewDidChangeSelection : ( NSNotification * ) notification {  }
+- ( void ) textViewDidChangeTypingAttributes : ( NSNotification * ) notification {  }
+- ( NSString * ) textView : ( NSTextView * ) textView willDisplayToolTip : ( NSString * ) tooltip forCharacterAtIndex : ( unsigned ) characterIndex { return nil; }
+- ( NSArray * ) textView : ( NSTextView * ) textView completions : ( NSArray * ) words forPartialWordRange : ( NSRange ) charRange indexOfSelectedItem : ( int * ) index { return nil; }
 - ( BOOL ) textView : ( NSTextView * ) textView shouldChangeTextInRange : ( NSRange ) affectedCharRange replacementString : ( NSString * ) replacementString { return NO; }
 - ( BOOL ) textView : ( NSTextView * ) textView doCommandBySelector : ( SEL ) commandSelector { return NO; }
 - ( BOOL ) textView : ( NSTextView * ) textView clickedOnLink : ( id ) link { return NO; }
@@ -560,6 +703,7 @@
 - ( NSToolbarItem * ) toolbar : ( NSToolbar * ) toolbar itemForItemIdentifier : ( NSString * ) itemIdentifier willBeInsertedIntoToolbar : ( BOOL ) flag { return nil; }
 - ( NSArray * ) toolbarDefaultItemIdentifiers : ( NSToolbar * ) toolbar { return nil; }
 - ( NSArray * ) toolbarAllowedItemIdentifiers : ( NSToolbar * ) toolbar { return nil; }
+- ( NSArray * ) toolbarSelectableItemIdentifiers : ( NSToolbar * ) toolbar { return nil; }
 
 // @interface NSObject ( NSToolbarNotifications )
 - ( void ) toolbarWillAddItem : ( NSNotification * ) notification {  }
@@ -570,6 +714,27 @@
 - ( BOOL ) validateToolbarItem : ( NSToolbarItem * ) theItem { return NO; }
 
 /**** NSWindowScripting.h ****/
+/**** NSATSTypesetter.h ****/
+/**** NSKeyValueBinding.h ****/
+// @interface NSObject ( NSKeyValueBindingCreation )
++ ( void ) exposeBinding : ( NSString * ) binding {  }
+- ( NSArray * ) exposedBindings { return nil; }
+- ( Class ) valueClassForBinding : ( NSString * ) binding { return nil; }
+- ( void ) bind : ( NSString * ) binding toObject : ( id ) observable withKeyPath : ( NSString * ) keyPath options : ( NSDictionary * ) options {  }
+- ( void ) unbind : ( NSString * ) binding {  }
+
+// @interface NSObject ( NSPlaceholders )
++ ( void ) setDefaultPlaceholder : ( id ) placeholder forMarker : ( id ) marker withBinding : ( NSString * ) binding {  }
++ ( id ) defaultPlaceholderForMarker : ( id ) marker withBinding : ( NSString * ) binding { return nil; }
+
+// @interface NSObject ( NSEditorRegistration )
+- ( void ) objectDidBeginEditing : ( id ) editor {  }
+- ( void ) objectDidEndEditing : ( id ) editor {  }
+
+// @interface NSObject ( NSEditor )
+- ( void ) discardEditing {  }
+- ( BOOL ) commitEditing { return NO; }
+
 
 
 @end
